var should = require('should')
var readFile = require('imacros-read-file')
var upload = require('../index')
var downloadBase64 = require('download-base64-imacros')
runTests(function (err, reply) {
  if (err) {
    alert('check test suite fails with error: ' + JSON.stringify(err))
    return false
  }
  iimDisplay('Success! Checks test suite passes')
})

function runTests(cb) {
  iimPlay('CODE: TAG POS=1 TYPE=BODY ATTR= EXTRACT=TXT')
  var configFilePath = 'file:///users/noah/src/node/docparse/scrapers/imacros/pdfer/login/test/config.json'
  loadConfigFile(configFilePath, function (err, config) {
    should.not.exist(err, 'error loading config file')
    var url = 'file:///users/noah/src/node/docparse/scrapers/imacros/pdfer/upload/test/data/multipage_raw.pdf'
    downloadBase64(url, function (err, base64) {
      if (err) { return cb(err) }
      var data = {
        config: config,
        base64: base64,
        type: 'ocr'
      }
      upload(data, function (err, responseData) {
        if (err) { return cb(err) }
        alert('uplaod resData: ' + JSON.stringify(responseData, null, ' '))
        cb()
      })
    })
  })
}

function loadConfigFile(filePath, cb) {
  readFile(filePath, function (err, reply) {
    if (err) { return cb(err) }
    var data = JSON.parse(reply)
    cb(null, data)
  })
}
